devproject/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.utils import timezone
from django.views.decorators.cache import cache_page
from django.views.decorators.http import last_modified
from django.views.i18n import JavaScriptCatalog

from misago.users.forms.auth import AdminAuthenticationForm


admin.autodiscover()
admin.site.login_form = AdminAuthenticationForm


urlpatterns = [
    url(r"^", include("misago.urls", namespace="misago")),
    url(r"^", include("social_django.urls", namespace="social")),
    # Javascript translations
    url(
        r"^django-i18n.js$",
        last_modified(lambda req, **kw: timezone.now())(
            cache_page(86400 * 2, key_prefix="misagojsi18n")(
                JavaScriptCatalog.as_view(packages=["misago"])
            )
        ),
        name="django-i18n",
    ),
    # Uncomment next line if you plan to use Django admin for 3rd party apps
    url(r"^django-admin/", admin.site.urls),
]


# If debug mode is enabled, include debug toolbar
if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [url(r"^__debug__/", include(debug_toolbar.urls))]


# Use static file server for static and media files (debug only)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)


# Error Handlers
# Misago needs those handlers to deal with errors raised by it's middlewares
# If you replace those handlers with custom ones, make sure you decorate them
# with shared_403_exception_handler or shared_404_exception_handler
# decorators that are defined in misago.views.errorpages module!
handler403 = "misago.core.errorpages.permission_denied"
handler404 = "misago.core.errorpages.page_not_found"

misago/admin/urls.py
from django.conf.urls import url

from .. import admin
from .views import auth, index

urlpatterns = [
    # "misago:admin:index" link symbolises "root" of Misago admin links space
    # any request with path that falls below this one is assumed to be directed
    # at Misago Admin and will be checked by Misago Admin Middleware
    url(r"^$", index.admin_index, name="index"),
    url(r"^logout/$", auth.logout, name="logout"),
]

# Discover admin and register patterns
admin.discover_misago_admin()
urlpatterns += admin.urlpatterns()

misago/markup/urls.py
from django.conf.urls import url

from .api import parse_markup

urlpatterns = [url(r"^parse-markup/$", parse_markup, name="parse-markup")]

misago/urls.py
from django.conf.urls import include, url
from django.views.generic import TemplateView

from .conf import settings
from .core.views import forum_index

app_name = "misago"

# Register Misago Apps
urlpatterns = [
    url(r"^", include("misago.analytics.urls")),
    url(r"^", include("misago.legal.urls")),
    url(r"^", include("misago.users.urls")),
    url(r"^", include("misago.categories.urls")),
    url(r"^", include("misago.threads.urls")),
    url(r"^", include("misago.search.urls")),
    # default robots.txt
    url(
        r"^robots.txt$",
        TemplateView.as_view(
            content_type="text/plain", template_name="misago/robots.txt"
        ),
    ),
    # "misago:index" link symbolises "root" of Misago links space
    # any request with path that falls below this one is assumed to be directed
    # at Misago and will be handled by misago.views.exceptionhandler if it
    # results in Http404 or PermissionDenied exception
    url(r"^$", forum_index, name="index"),
]


# Register API
apipatterns = [
    url(r"^", include("misago.categories.urls.api")),
    url(r"^", include("misago.legal.urls.api")),
    url(r"^", include("misago.markup.urls")),
    url(r"^", include("misago.threads.urls.api")),
    url(r"^", include("misago.users.urls.api")),
    url(r"^", include("misago.search.urls.api")),
]

urlpatterns += [url(r"^api/", include((apipatterns, "api"), namespace="api"))]


# Register Misago ACP
if settings.MISAGO_ADMIN_PATH:
    # Admin patterns recognised by Misago
    adminpatterns = [url(r"^", include("misago.admin.urls"))]

    admin_prefix = r"^%s/" % settings.MISAGO_ADMIN_PATH
    urlpatterns += [
        url(admin_prefix, include((adminpatterns, "admin"), namespace="admin"))
    ]

misago/acl/models.py
from django.contrib.postgres.fields import JSONField
from django.db import models
from django.utils.translation import gettext as _

from .cache import clear_acl_cache


def permissions_default():
    return {}


class BaseRole(models.Model):
    name = models.CharField(max_length=255)
    special_role = models.CharField(max_length=255, null=True, blank=True)
    permissions = JSONField(default=permissions_default)

    class Meta:
        abstract = True

    def __str__(self):
        return _(self.name)

    def save(self, *args, **kwargs):
        if self.pk:
            clear_acl_cache()
        return super().save(*args, **kwargs)

    def delete(self, *args, **kwargs):
        clear_acl_cache()
        return super().delete(*args, **kwargs)


class Role(BaseRole):
    pass

misago/cache/models.py
from django.db import models

from .utils import generate_version_string


class CacheVersion(models.Model):
    cache = models.CharField(max_length=128, primary_key=True)
    version = models.CharField(max_length=8, default=generate_version_string)

misago/categories/models.py
from django.core.cache import cache
from django.db import models
from mptt.managers import TreeManager
from mptt.models import MPTTModel, TreeForeignKey

from . import PRIVATE_THREADS_ROOT_NAME, THREADS_ROOT_NAME
from ..acl.cache import clear_acl_cache
from ..acl.models import BaseRole
from ..conf import settings
from ..core.utils import slugify
from ..threads.threadtypes import trees_map

CACHE_NAME = "misago_categories_tree"


class CategoryManager(TreeManager):
    def private_threads(self):
        return self.get_special(PRIVATE_THREADS_ROOT_NAME)

    def root_category(self):
        return self.get_special(THREADS_ROOT_NAME)

    def get_special(self, special_role):
        cache_name = "%s_%s" % (CACHE_NAME, special_role)

        special_category = cache.get(cache_name, "nada")
        if special_category == "nada":
            special_category = self.get(special_role=special_role)
            cache.set(cache_name, special_category)
        return special_category

    def all_categories(self, include_root=False):
        tree_id = trees_map.get_tree_id_for_root(THREADS_ROOT_NAME)
        queryset = self.filter(tree_id=tree_id)
        if not include_root:
            queryset = queryset.filter(level__gt=0)
        return queryset.order_by("lft")

    def get_cached_categories_dict(self):
        categories_dict = cache.get(CACHE_NAME, "nada")
        if categories_dict == "nada":
            categories_dict = self.get_categories_dict_from_db()
            cache.set(CACHE_NAME, categories_dict)
        return categories_dict

    def get_categories_dict_from_db(self):
        categories_dict = {}
        for category in self.all_categories(include_root=True):
            categories_dict[category.pk] = category
        return categories_dict

    def clear_cache(self):
        cache.delete(CACHE_NAME)


class Category(MPTTModel):
    parent = TreeForeignKey(
        "self", null=True, blank=True, related_name="children", on_delete=models.CASCADE
    )
    special_role = models.CharField(max_length=255, null=True, blank=True)
    name = models.CharField(max_length=255)
    slug = models.CharField(max_length=255)
    description = models.TextField(null=True, blank=True)
    is_closed = models.BooleanField(default=False)
    threads = models.PositiveIntegerField(default=0)
    posts = models.PositiveIntegerField(default=0)
    last_post_on = models.DateTimeField(null=True, blank=True)
    last_thread = models.ForeignKey(
        "misago_threads.Thread",
        related_name="+",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    last_thread_title = models.CharField(max_length=255, null=True, blank=True)
    last_thread_slug = models.CharField(max_length=255, null=True, blank=True)
    last_poster = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="+",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    last_poster_name = models.CharField(max_length=255, null=True, blank=True)
    last_poster_slug = models.CharField(max_length=255, null=True, blank=True)
    require_threads_approval = models.BooleanField(default=False)
    require_replies_approval = models.BooleanField(default=False)
    require_edits_approval = models.BooleanField(default=False)
    prune_started_after = models.PositiveIntegerField(default=0)
    prune_replied_after = models.PositiveIntegerField(default=0)
    archive_pruned_in = models.ForeignKey(
        "self",
        related_name="pruned_archive",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    css_class = models.CharField(max_length=255, null=True, blank=True)

    objects = CategoryManager()

    def __str__(self):
        return str(self.thread_type.get_category_name(self))

    @property
    def thread_type(self):
        return trees_map.get_type_for_tree_id(self.tree_id)

    def delete(self, *args, **kwargs):
        Category.objects.clear_cache()
        clear_acl_cache()
        return super().delete(*args, **kwargs)

    def synchronize(self):
        threads_queryset = self.thread_set.filter(is_hidden=False, is_unapproved=False)
        self.threads = threads_queryset.count()

        if self.threads:
            replies_sum = threads_queryset.aggregate(models.Sum("replies"))
            self.posts = self.threads + replies_sum["replies__sum"]
        else:
            self.posts = 0

        if self.threads:
            last_thread_qs = threads_queryset.filter(
                is_hidden=False, is_unapproved=False
            )
            last_thread = last_thread_qs.order_by("-last_post_on")[:1][0]
            self.set_last_thread(last_thread)
        else:
            self.empty_last_thread()

    def delete_content(self):
        from .signals import delete_category_content

        delete_category_content.send(sender=self)

    def move_content(self, new_category):
        from .signals import move_category_content

        move_category_content.send(sender=self, new_category=new_category)

    def get_absolute_url(self):
        return self.thread_type.get_category_absolute_url(self)

    def get_last_thread_url(self):
        return self.thread_type.get_category_last_thread_url(self)

    def get_last_thread_new_url(self):
        return self.thread_type.get_category_last_thread_new_url(self)

    def get_last_post_url(self):
        return self.thread_type.get_category_last_post_url(self)

    def set_name(self, name):
        self.name = name
        self.slug = slugify(name)

    def set_last_thread(self, thread):
        self.last_post_on = thread.last_post_on
        self.last_thread = thread
        self.last_thread_title = thread.title
        self.last_thread_slug = thread.slug
        self.last_poster = thread.last_poster
        self.last_poster_name = thread.last_poster_name
        self.last_poster_slug = thread.last_poster_slug

    def empty_last_thread(self):
        self.last_post_on = None
        self.last_thread = None
        self.last_thread_title = None
        self.last_thread_slug = None
        self.last_poster = None
        self.last_poster_name = None
        self.last_poster_slug = None

    def has_child(self, child):
        return child.lft > self.lft and child.rght < self.rght


class CategoryRole(BaseRole):
    pass


class RoleCategoryACL(models.Model):
    role = models.ForeignKey(
        "misago_acl.Role", related_name="categories_acls", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        "Category", related_name="category_role_set", on_delete=models.CASCADE
    )
    category_role = models.ForeignKey(CategoryRole, on_delete=models.CASCADE)

misago/core/testproject/models.py
class Model:
    def __init__(self, pk, slug):
        self.id, self.pk = pk, pk
        self.slug = slug

misago/readtracker/models.py
from django.conf import settings
from django.db import models
from django.utils import timezone


class PostRead(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    category = models.ForeignKey("misago_categories.Category", on_delete=models.CASCADE)
    thread = models.ForeignKey("misago_threads.Thread", on_delete=models.CASCADE)
    post = models.ForeignKey("misago_threads.Post", on_delete=models.CASCADE)
    last_read_on = models.DateTimeField(default=timezone.now)

misago/themes/models.py
from django.db import models
from django.utils.translation import gettext
from mptt.models import MPTTModel, TreeForeignKey

from .uploadto import (
    generate_theme_dirname,
    upload_build_css_to,
    upload_source_css_to,
    upload_media_to,
    upload_media_thumbnail_to,
)


class Theme(MPTTModel):
    parent = TreeForeignKey(
        "self", on_delete=models.PROTECT, null=True, blank=True, related_name="children"
    )
    name = models.CharField(max_length=255)
    dirname = models.CharField(max_length=8, default=generate_theme_dirname)
    is_default = models.BooleanField(default=False)
    is_active = models.BooleanField(default=False)

    version = models.CharField(max_length=255, null=True, blank=True)
    author = models.CharField(max_length=255, null=True, blank=True)
    url = models.URLField(max_length=255, null=True, blank=True)

    class MPTTMeta:
        order_insertion_by = ["-is_default", "name"]

    def delete(self, *args, **kwargs):
        for css in self.css.all():
            css.delete()
        for media in self.media.all():
            media.delete()

        super().delete(*args, **kwargs)

    def __str__(self):
        if self.is_default:
            return gettext("Default Misago Theme")
        return self.name

    @property
    def level_range(self):
        return range(self.level)


class Css(models.Model):
    theme = models.ForeignKey(Theme, on_delete=models.PROTECT, related_name="css")

    name = models.CharField(max_length=255)
    url = models.URLField(max_length=255, null=True, blank=True)
    source_file = models.FileField(
        upload_to=upload_source_css_to, max_length=255, null=True, blank=True
    )
    source_hash = models.CharField(max_length=8, null=True, blank=True)
    source_needs_building = models.BooleanField(default=False)
    build_file = models.FileField(
        upload_to=upload_build_css_to, max_length=255, null=True, blank=True
    )
    build_hash = models.CharField(max_length=8, null=True, blank=True)
    size = models.PositiveIntegerField(default=0)

    order = models.IntegerField(default=0)
    modified_on = models.DateTimeField(auto_now=True)

    class Meta:
        ordering = ["order"]

    def delete(self, *args, **kwargs):
        if self.source_file:
            self.source_file.delete(save=False)
        if self.build_file:
            self.build_file.delete(save=False)

        super().delete(*args, **kwargs)

    def __str__(self):
        return self.name


class Media(models.Model):
    theme = models.ForeignKey(Theme, on_delete=models.PROTECT, related_name="media")

    name = models.CharField(max_length=255)
    file = models.ImageField(upload_to=upload_media_to, max_length=255)
    hash = models.CharField(max_length=8)
    type = models.CharField(max_length=255)
    width = models.PositiveIntegerField(default=0)
    height = models.PositiveIntegerField(default=0)
    size = models.PositiveIntegerField()
    thumbnail = models.ImageField(
        upload_to=upload_media_thumbnail_to, max_length=255, null=True, blank=True
    )
    modified_on = models.DateTimeField(auto_now=True)

    class Meta:
        ordering = ["name"]

    def delete(self, *args, **kwargs):
        self.file.delete(save=False)
        if self.thumbnail:
            self.thumbnail.delete(save=False)
        super().delete(*args, **kwargs)

    def __str__(self):
        return self.name

misago/threads/models/attachmenttype.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class AttachmentType(models.Model):
    ENABLED = 0
    LOCKED = 1
    DISABLED = 2

    name = models.CharField(max_length=255)
    extensions = models.CharField(max_length=255)
    mimetypes = models.CharField(null=True, blank=True, max_length=255)
    size_limit = models.PositiveIntegerField(default=1024)
    status = models.PositiveIntegerField(
        default=ENABLED,
        choices=[
            (ENABLED, _("Allow uploads and downloads")),
            (LOCKED, _("Allow downloads only")),
            (DISABLED, _("Disallow both uploading and downloading")),
        ],
    )

    limit_uploads_to = models.ManyToManyField(
        "misago_acl.Role", related_name="+", blank=True
    )
    limit_downloads_to = models.ManyToManyField(
        "misago_acl.Role", related_name="+", blank=True
    )

    def __str__(self):
        return self.name

    @property
    def is_enabled(self):
        return self.status == AttachmentType.ENABLED

    @property
    def is_locked(self):
        return self.status == AttachmentType.LOCKED

    @property
    def extensions_list(self):
        if self.extensions:
            return self.extensions.split(",")
        return []

    @property
    def mimetypes_list(self):
        if self.mimetypes:
            return self.mimetypes.split(",")
        return []

misago/templates/misago/admin/agreements/form.html
{% extends "misago/admin/generic/form.html" %}
{% load i18n misago_admin_form %}


{% block title %}
{% if target.pk %}
{% trans target.get_final_title %}
{% else %}
{% trans "New agreement" %}
{% endif %} | {{ active_link.name }} | {{ block.super }}
{% endblock title %}


{% block page-header %}
{{ block.super }}
{% if target.pk %}
  <small>
    {{ target.get_final_title }}
  </small>
{% endif %}
{% endblock page-header %}


{% block page-actions %}
{% if target.get_absolute_url %}
  <div class="col-auto page-action">
    <a href="{{ target.get_absolute_url }}" class="btn btn-primary btn-sm">
      <span class="fas fa-external-link-alt"></span>
      {% trans "View on site" %}
    </a>
  </div>
{% endif %}
{% endblock %}


{% block form-header %}
{% if target.pk %}
  {% trans "Edit agreement" %}
{% else %}
  {% trans "New agreement" %}
{% endif %}
{% endblock %}


{% block form-body %}
<div class="form-fieldset">
  <fieldset>
    <legend>{% trans "Basic settings" %}</legend>

    {% form_row form.type %}
    {% form_row form.title %}
    {% form_row form.is_active %}

  </fieldset>
</div>
<div class="form-fieldset">
  <fieldset>
    <legend>{% trans "Agreement contents" %}</legend>

    <div class="alert alert-info" role="alert">
      {% trans "Fill in one of the fields." %}
    </div>

    {% form_row form.link %}
    {% form_row form.text %}

  </fieldset>
</div>
{% endblock form-body %}

misago/templates/misago/admin/agreements/list.html
{% extends "misago/admin/generic/list.html" %}
{% load i18n misago_admin_form misago_capture %}


{% block page-actions %}
<div class="col-auto page-action">
  <a href="{% url 'misago:admin:settings:agreements:new' %}" class="btn btn-primary btn-sm">
    <span class="fa fa-plus-circle"></span>
    {% trans "New agreement" %}
  </a>
</div>
{% endblock %}


{% block table-header %}
<th style="width: 1px;">&nbsp;</th>
<th>{% trans "Agreement" %}</th>
<th style="width: 1px;">&nbsp;</th>
<th style="width: 180px;">{% trans "Type" %}</th>
<th style="width: 250px;">{% trans "Created" %}</th>
<th style="width: 250px;">{% trans "Modified" %}</th>
<th style="width: 1px;">&nbsp;</th>
{% endblock table-header %}


{% block table-row %}
<td class="pr-0">
  {% if item.is_active %}
    <a href="{{ item.get_absolute_url }}" class="btn btn-light btn-sm">
      <span class="fas fa-external-link-alt"></span>
    </a>
  {% endif %}
</td>
<td class="pr-0 small">
  <a href="{% url 'misago:admin:settings:agreements:edit' pk=item.pk %}" class="item-name">
    {{ item.get_final_title }}
  </a>
</td>
<td class="badges-list">
  {% if item.is_active %}
    <span class="badge badge-success" data-tooltip="top" title="{% trans 'Users are required to accept this agreement to use the site' %}">
      {% trans "Active" %}
    </span>
  {% endif %}
</td>
<td class="small">
  {{ item.get_type_display }}
</td>
<td class="small">
  {% capture trimmed as created_on %}
    <abbr data-timestamp="{{ item.created_on.isoformat }}" data-format="LL"></abbr>
  {% endcapture %}
  {% capture trimmed as created_by %}
    {% if item.created_by %}
      <a href="{{ item.created_by.get_absolute_url }}" class="item-title">{{ item.created_by }}</a>
    {% else %}
      <span class="item-title">{{ item.created_by_name }}</span>
    {% endif %}
  {% endcapture %}
  {% blocktrans trimmed with created_on=created_on|safe created_by=created_by|safe %}
    {{ created_on }} by {{ created_by }}
  {% endblocktrans %}
</td>
<td class="small">
  {% if item.last_modified_on %}
    {% capture trimmed as last_modified_on %}
      <abbr data-timestamp="{{ item.last_modified_on.isoformat }}" data-format="LL">
        {{ item.last_modified_on }}
      </abbr>
    {% endcapture %}
    {% capture trimmed as last_modified_by %}
      {% if item.last_modified_by %}
        <a href="{{ item.last_modified_by.get_absolute_url }}" class="item-title">{{ item.last_modified_by }}</a>
      {% else %}
        <span class="item-title">{{ item.last_modified_by }}</span>
      {% endif %}
    {% endcapture %}
    {% blocktrans trimmed with last_modified_on=last_modified_on|safe last_modified_by=last_modified_by|safe %}
      {{ last_modified_on }} by {{ last_modified_by }}
    {% endblocktrans %}
  {% else %}
    <em>{% trans "never" %}</em>
  {% endif %}
</td>
<td>
  <div class="dropdown">
    <button class="btn btn-light btn-sm dropdown-toggle" type="button" id="item-optioms-{{ item.pk }}" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      <i class="fas fa-ellipsis-h"></i>
    </button>
    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="item-optioms-{{ item.pk }}">
      {% if not item.is_active %}
        <form action="{% url 'misago:admin:settings:agreements:set-as-active' pk=item.pk %}" method="post" data-set-as-active-confirmation="true">
          {% csrf_token %}
          <button class="dropdown-item">
            {% trans "Set as active" %}
          </button>
        </form>
      {% else %}
        <form action="{% url 'misago:admin:settings:agreements:disable' pk=item.pk %}" method="post" data-disable-confirmation="true">
          {% csrf_token %}
          <button class="dropdown-item">
            {% trans "Disable agreement" %}
          </button>
        </form>
      {% endif %}
      <a class="dropdown-item" href="{% url 'misago:admin:settings:agreements:edit' pk=item.pk %}">
        {% trans "Edit agreement" %}
      </a>
      <form action="{% url 'misago:admin:settings:agreements:delete' pk=item.pk %}" method="post" data-delete-confirmation="true">
        {% csrf_token %}
        <button class="dropdown-item">
          {% trans "Remove agreement" %}
        </button>
      </form>
    </div>
  </div>
</td>
{% endblock %}


{% block blankslate %}
<td colspan="8">
  {% if active_filters %}
    {% trans "No agreements matching criteria exist." %}
  {% else %}
    {% trans "No agreements are set." %}
  {% endif %}
</td>
{% endblock blankslate %}


{% block javascripts %}
{{ block.super }}
<script type="text/javascript">
  window.misago.initConfirmation(
    "[data-set-as-active-confirmation]",
    "{% trans 'Are you sure you want to set this agreement as active for its type?' %}"
  )
  window.misago.initConfirmation(
    "[data-disable-confirmation]",
    "{% trans 'Are you sure you want to disable this agreement?' %}"
  )
  window.misago.initConfirmation(
    "[data-delete-confirmation]",
    "{% trans 'Are you sure you want to remove this agreement?' %}"
  )
</script>
{% endblock %}


{% block filters-modal-body %}
<div class="row">
  <div class="col">
    {% form_row filter_form.type %}
  </div>
</div>
<div class="row">
  <div class="col">
    {% form_row filter_form.content %}
  </div>
</div>
{% endblock filters-modal-body %}